Index: trunk/src/story_entities/movie_loader.cc
===================================================================
--- trunk/src/story_entities/movie_loader.cc	(revision 7009)
+++ trunk/src/story_entities/movie_loader.cc	(revision 7010)
@@ -47,4 +47,10 @@
 
   LoadParam(root, "name", this, MovieLoader, loadMovie);
+  LoadParam(root, "fps", this, MovieLoader, setFPS);
+}
+
+void MovieLoader::setFPS(float fps)
+{
+  this->movie_player->setFPS(fps);
 }
 
Index: trunk/src/story_entities/movie_loader.h
===================================================================
--- trunk/src/story_entities/movie_loader.h	(revision 7009)
+++ trunk/src/story_entities/movie_loader.h	(revision 7010)
@@ -41,4 +41,5 @@
   private:
     void loadMovie(const char* filename);
+    void setFPS(float fps);
     void tick();
     void draw() const;
Index: trunk/src/story_entities/story_entity.cc
===================================================================
--- trunk/src/story_entities/story_entity.cc	(revision 7009)
+++ trunk/src/story_entities/story_entity.cc	(revision 7010)
@@ -77,4 +77,17 @@
   .describe("Sets the ID of the next StoryEntity");
 
+  LoadParam(root, "menu-entry", this, StoryEntity, addToGameMenu)
+      .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
+
+
+  LoadParam(root, "description", this, StoryEntity, setDescription)
+      .describe("Sets the description of this StoryEntity");
+
+  LoadParam(root, "menu-item-image", this, StoryEntity, setMenuItemImage)
+      .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
+
+  LoadParam(root, "screenshoot", this, StoryEntity, setMenuScreenshoot)
+      .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
+
   PRINTF(4)("Loaded StoryEntity specific stuff\n");
 }
@@ -152,7 +165,4 @@
     .describe("Sets the description of this StoryEntity");
 
-    LoadParam(root, "menu-entry", this, StoryEntity, addToGameMenu)
-    .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
-
     LoadParam(root, "menu-item-image", this, StoryEntity, setMenuItemImage)
     .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
Index: trunk/src/world_entities/movie_entity.cc
===================================================================
--- trunk/src/world_entities/movie_entity.cc	(revision 7009)
+++ trunk/src/world_entities/movie_entity.cc	(revision 7010)
@@ -46,5 +46,4 @@
   counter = 0;
   timer = 0;
-  fps = media_container->getFPS();
 }
 
@@ -66,4 +65,11 @@
   //LoadParam(root, "rotation", this, MovieEntity, setRotation);
   LoadParam(root, "size", this, MovieEntity, setSize);
+  LoadParam(root, "fps", this, MovieEntity, setFPS);
+}
+
+void MovieEntity::setFPS(float fps)
+{
+  this->fps = fps;
+PRINTF(0)("fps: %f\n", fps);
 }
 
@@ -71,5 +77,8 @@
 {
   if(media_container->loadMedia(filename))
+  {
     mediaLoaded = true;
+    fps = media_container->getFPS();
+  }
   else
     mediaLoaded = false;
@@ -78,4 +87,5 @@
 void MovieEntity::setAxis(float axis)
 {
+PRINTF(0)("fps: %f\n", fps);
   this->axis = axis;
 }
@@ -141,4 +151,5 @@
   glPushAttrib(GL_ENABLE_BIT);
   glDisable(GL_LIGHTING);
+  glDisable(GL_BLEND);
 
   glEnable(GL_TEXTURE_2D);
Index: trunk/src/world_entities/movie_entity.h
===================================================================
--- trunk/src/world_entities/movie_entity.h	(revision 7009)
+++ trunk/src/world_entities/movie_entity.h	(revision 7010)
@@ -41,4 +41,5 @@
     void setRotation(float rotation);
     void setSize(float width, float height);
+    void setFPS(float fps);
 
 };
Index: trunk/src/world_entities/playable.cc
===================================================================
--- trunk/src/world_entities/playable.cc	(revision 7009)
+++ trunk/src/world_entities/playable.cc	(revision 7010)
@@ -305,10 +305,10 @@
 {
   SYNCHELP_READ_BEGIN();
-  
+
   byte b;
   SYNCHELP_READ_BYTE( b, NWT_PL_B );
-  
+
   byte flags;
-  
+
   if ( b == DATA_FLAGS )
   {
@@ -316,8 +316,8 @@
 
     bFire = (flags & FLAGS_bFire) != 0;
-    
+
     return SYNCHELP_READ_N;
   }
-  
+
   if ( b == DATA_SCORE )
   {
@@ -325,5 +325,5 @@
     SYNCHELP_READ_BYTE( newScore, NWT_PL_SCORE );
     setScore( newScore );
-    
+
     return SYNCHELP_READ_N;
   }
@@ -335,5 +335,5 @@
 {
   SYNCHELP_WRITE_BEGIN();
-  
+
   if ( score != oldScore && isServer() )
   {
@@ -341,8 +341,8 @@
     SYNCHELP_WRITE_INT( score, NWT_PL_SCORE );
     oldScore = score;
-    
+
     return SYNCHELP_WRITE_N;
   }
-  
+
   byte flags = 0;
 