Index: code/branches/presentation3/data/levels/PresentationFS10.oxw
===================================================================
--- code/branches/presentation3/data/levels/PresentationFS10.oxw	(revision 7027)
+++ code/branches/presentation3/data/levels/PresentationFS10.oxw	(revision 7027)
@@ -0,0 +1,116 @@
+<?lua
+  include("stats.oxo")
+  include("hudtemplates3.oxo")
+?>
+
+<?lua
+  include("templates/spaceship_assff.oxt")
+  include("templates/spaceship_pirate.oxt")
+  include("templates/pickup_representation_templates.oxt")
+?>
+
+<Level
+ name         = "Sample"
+ description  = "Just a few tests"
+>
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/Starbox"
+  >
+
+    <?lua
+      include("includes/pickups.oxi")
+    ?>
+
+    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
+    <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+
+    <Billboard position="12.5, -30, -500" material="Banners/Pickups" scale="0.5"/>
+    <Billboard position="500, -30, -500" material="Banners/Drone" scale="0.5"/>
+
+    <!-- Shield pickups -->
+
+    <PickupSpawner position="-25,-50,-500" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+      <pickup>
+        <ShieldPickup template=hugeshieldpickup />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- Health pickups -->
+
+    <PickupSpawner position="0,-50,-500" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
+      <pickup>
+        <HealthPickup template=hugehealthpickup />
+      </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="25,-50,-500" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
+      <pickup>
+        <HealthPickup template=crazyhealthpickup />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- Speed pickups -->
+
+    <PickupSpawner position="50,-50,-500" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
+      <pickup>
+        <SpeedPickup template=hugespeedpickup />
+      </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="50,-75,-500" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
+      <pickup>
+        <SpeedPickup template=smalljumppickup />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- Invisible pickups -->
+
+    <PickupSpawner position="25,-75,-500" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+      <pickup>
+        <InvisiblePickup template=hugeinvisiblepickup />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- Meta pickups -->
+
+    <PickupSpawner position="0,-75,-500" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+      <pickup>
+        <MetaPickup metaType="use" />
+      </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="-25,-75,-500" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+      <pickup>
+        <MetaPickup metaType="drop" />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- Pickup Collection pickups -->
+
+    <PickupSpawner position="0,-100,-500" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
+      <pickup>
+        <PickupCollection template=triplehealthspeedinvisibilitypickup />
+      </pickup>
+    </PickupSpawner>
+
+    <!-- PickupRepresentation for the pickup below, since it is not a standard pickup provided by pickups.oxi -->
+    <PickupRepresentation
+      pickupName = "Medium Health Pack"
+      pickupDescription = "Once used adds a medium amout of health to the ship."
+      spawnerTemplate = "mediumhealthpickupRepresentation"
+      inventoryRepresentation = "MediumHealth"
+    >
+      <pickup>
+        <HealthPickup health=50 activationType="onUse" durationType="once" />
+      </pickup>
+    </PickupRepresentation>
+
+    <PickupSpawner position="25,-100,-500" respawnTime="60" triggerDistance="20" maxSpawnedItems="5">
+      <pickup>
+        <HealthPickup health=50 activationType=onUse durationType=once />
+      </pickup>
+    </PickupSpawner>
+
+  </Scene>
+</Level>
Index: code/branches/presentation3/src/orxonox/graphics/AnimatedModel.cc
===================================================================
--- code/branches/presentation3/src/orxonox/graphics/AnimatedModel.cc	(revision 7025)
+++ code/branches/presentation3/src/orxonox/graphics/AnimatedModel.cc	(revision 7027)
@@ -22,10 +22,10 @@
  *   Author:
  *      Benjamin de Capitani
- *   Co-authors:
- *      ...
+ *
  *
  */
- #include "AnimatedModel.h"
- #include <OgreEntity.h>
+
+#include "AnimatedModel.h"
+#include <OgreEntity.h>
 #include <Ogre.h>
 #include <deque>